--table to store all variables needed for sliders notifier "wiring" to the pattern editor
--g_target = {}
--g_target.column_index = 1
--g_target.column_type = "note"
--g_target.value_type = "volume"
--g_target.default_note = 48 --C-4 = 48 in renoise
--g_target.all_note_columns = {}
--g_target.all_fx_columns = {}




--[[

local table_of_ids = {
  "delay button",
  "0CXY button",
  "pitch button",
  "0AXY button",
  "pan button",
  "0UXX button",
  "0DXX button",
  "0GXX button",
  "0IXX button",
  "0OXX button",
  "0TXY button",
  "0SXX button",
  "0BXX button",
  "0VXY button",
  "0NXY button",
  "0EXX button",
 }--]]
  
g_slider_lane_target = {}

--gets the note column target when delay pitch or pan are chosen
----------------------------------------------------------------
function set_g_slider_lane_target_note_col()
----------------------------------------------------------------

  --pattern variables
  local song = renoise.song() 
  local pattern = renoise.song().selected_pattern
  local pattern_length = pattern.number_of_lines
  local pattern_track = renoise.song().selected_pattern_track
  
  for col = 1,12 do 
    --declare/reset column table
    local column = {}
    for line = 1, pattern_length do
      column[line] = pattern_track:line(line):note_column(col)
    end
    --update g_target table
    g_target.all_note_columns[col] = column
    --set column type property to note
    g_target.column_type = "note"
  end
end

--gets the fx column target when Fx commands are chosen
----------------------------------------------------------------
function set_g_slider_lane_target_effect_col()
----------------------------------------------------------------
 --pattern variables
  local song = renoise.song() 
  local pattern = renoise.song().selected_pattern
  local pattern_length = pattern.number_of_lines
  local pattern_track = renoise.song().selected_pattern_track

  --loop fx columns
  for col = 1, song.selected_track.max_effect_columns  do 
    --declare/reset column table
    local column = {}
    for line = 1, pattern_length do
      column[line] = pattern_track:line(line):effect_column(col)
    end
    --update g_target table
    g_target.all_fx_columns[col] = column
    --set column type property to effect
    g_target.column_type = "effect"
  end 
end
----------------------------------------------------------
-----------------notifier functions-----------------------
----------------------------------------------------------


--Popup Target 1) delay chosen
---------------------------------------
function volume_and_note_target_notifier()
--------------------------------------
  local song = renoise.song()
  --update global to point at current note column in pattern
  set_g_slider_lane_target_note_col()

  --update sliders max value
  for i = 1,tool_range do
    vb.views["slider"..i].max = 129
  end
  --update global
  g_target.value_type = "note + volume" 

  song.selected_track.volume_column_visible = true

end

--Popup Target 1) delay chosen
---------------------------------------
function volume_target_notifier()
--------------------------------------
  local song = renoise.song()
  --update global to point at current note column in pattern
  set_g_slider_lane_target_note_col()

  --update sliders max value
  for i = 1,tool_range do
    vb.views["slider"..i].max = 129
  end
  --update global
  g_target.value_type = "volume" 

  song.selected_track.volume_column_visible = true

end


 
--Popup Target 1) delay chosen
---------------------------------------
function delay_target_notifier()
-------------------------------------- 
  local song = renoise.song()
  --update global to point at current note column in pattern
  set_g_slider_lane_target_note_col()

  --update sliders max value
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  --update globalglide
  g_target.value_type = "delay" 
  song.selected_track.delay_column_visible = true

end

--Popup Target 2) pitch chosen
---------------------------------------
function pitch_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_note_col()
  
   --update sliders max value
  for i = 1,tool_range do
    vb.views["slider"..i].max = 119 --miss off 120 and 121 which are off and empty `---`
  end
  --update global
  g_target.value_type = "pitch"

end

--Popup Target3) Pan chosen
---------------------------------------
function pan_target_notifier()
--------------------------------------    
  local song = renoise.song()
  --update global to point at current note column in pattern
  set_g_slider_lane_target_note_col()
  
   --update sliders max value
  for i = 1,tool_range do
    vb.views["slider"..i].max = 127 
  end
  --update global
  g_target.value_type = "pan"
  --show panning lane
  song.selected_track.panning_column_visible = true
end



--Popup Target 5) 0Axy - Set arpeggio, x/y = first/second note offset in semitones. Using 0 for x or y will use the original note
----------------------------------------------------------------------------------------------------------------------------
---------------------------------------
function oaxy_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col()
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  --update global
  g_target.value_type = "0axy (Arpeggio)"
end

--Popup Target 6) 0Uxx - Slide pitch up by xx 1/16ths of a semitone (01 is 1/16th of a semitone, 08 is half a semitone, 10 is a whole semitone). 
----------------------------------------------------------------------------------------------------------------------------
---------------------------------------
function ouxx_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col()
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  --update global
  g_target.value_type = "0uxx (Slide Pitch up)"
end

---Dxx -  
--Popup Target 7 0Dxx - Slide pitch down by xx 1/16ths of a semitone (01 is 1/16th of a semitone, 08 is half a semitone, 10 is a whole semitone). 
----------------------------------------------------------------------------------------------------------------------------
---------------------------------------
function odxx_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col() 
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  --update global
  g_target.value_type = "0dxx (Slide Pitch Down)"
end

--Popup Target 8 0Gxx --Gxx - Glide towards given note by xx 1/16ths of a semitone (01 is 1/16th of a semitone, 08 is half a semitone, 10 is a whole semitone). A value of FF will make the slide instant.
----------------------------------------------------------------------------------------------------------------------------
---------------------------------------
function ogxx_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col()
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255 
  end
  
  --update global
  g_target.value_type = "0gxx (Glide Towards Note)"
end

---Dxx -  
--Popup Target 9 -Ixx - Fade volume in by xx volume units (-I01 inserted 256 times will slide from 0 to full volume, -I7F inserted twice will do the same much faster).
----------------------------------------------------------------------------------------------------------------------------
---------------------------------------
function oixx_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col()
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  
  --update global
  g_target.value_type = "0ixx (Fade Volume In)"
end

--Popup Target 10 --Oxx - Fade volume out by xx volume units.
----------------------------------------------------------------------
---------------------------------------
function ooxx_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col()
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  
  --update global
  g_target.value_type = "0oxx (Fade Volume Out)"
end

--Popup Target 11 ---Txy - Set tremolo (regular volume variation), x = speed, y = depth.
--------------------------------------------------------------------------
---------------------------------------
function otxy_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col() 
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  --update global
  g_target.value_type = "0txy (Tremolo)"
end

--Popup Target  0cxy fx --CUT command
---------------------------------------
function ocxy_target_notifier()
--------------------------------------
  local song = renoise.song()
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col()
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = song.transport.tpl --for ocxy the limit is renoise `ticks per line`
  end  
  --update global
  g_target.value_type = "0cxy (Cut Note)"
end

--Popup Target 12 -Sxx - Trigger sample slice number xx or offset xx.
--------------------------------------------------------------------------
---------------------------------------
function osxx_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col() 
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  --update global
  g_target.value_type = "0sxx (Trigger Sample Slice / Offset)"
end

--Popup Target 13 --Bxx - Play sample backwards (xx = 00) or forwards (xx = 01).
----------------------------------------------------------------------------
---------------------------------------
function obxx_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col()
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 1
  end
  --update global
  g_target.value_type = "0bxx (Play Backwards)"
end

--Popup Target 14---Vxy - Set vibrato (regular pitch variation), x = speed, y = depth.
-------------------------------------------------------------------------------
---------------------------------------
function ovxy_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col() 
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  --update global
  g_target.value_type = "0vxy (Vibrato)"
end

--Popup Target 15---Nxy - Set auto pan (regular pan variation), x = speed, y = depth.
-------------------------------------------------------------------------------
---------------------------------------
function onxy_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col() 
  
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  --update global
  g_target.value_type = "0nxy (Auto Pan)"
end

--Popup Target 16--Exx - Set the position of all active Envelope, AHDSR and Fader Modulation devices to offset xx.
--------------------------------------------------------------------------------------------------------
---------------------------------------
function oexx_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col()
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  --update global
  g_target.value_type = "0exx (Envelope Pos)"
end

--Popup Target 17-- USER automate any device parameter.
--------------------------------------------------------------------------------------------------------
---------------------------------------
function user_target_notifier()
--------------------------------------
  --update global to point at current note column in pattern
  set_g_slider_lane_target_effect_col()
  --update sliders max value for fx
  for i = 1,tool_range do
    vb.views["slider"..i].max = 255
  end
  --update global
  g_target.value_type = "DEVICE"
end




--table to store all variables needed for sliders notifier "wiring" to the pattern editor
--g_target = {}
--g_target.column_index = 1
--g_target.column_type = "note"
--g_target.value_type = "volume"
--g_target.all_note_columns = {}
--g_target.all_fx_columns = {}



--NOTE when adding functions to tables like this we leave off the parenthesis () otherwise they will fire
--on declaration
------------------------------------------------------------
--top slider
------------------------------------------------------------
--[[
local table_of_note_effects = {
 "Pitch",
 "Note + Vol.",
 "Volume",
 "Pan",
 "Delay",
}
--]]

------------------------------------------------------------
--notes table of functions
------------------------------------------------------------
g_target_notifier_tab_notes = {}

g_target_notifier_tab_notes[1] = pitch_target_notifier--pitch
g_target_notifier_tab_notes[2] = volume_and_note_target_notifier --"note + volume"
g_target_notifier_tab_notes[3] = volume_target_notifier--volume
g_target_notifier_tab_notes[4] = pan_target_notifier--pan
g_target_notifier_tab_notes[5] = delay_target_notifier--delay

------------------------------------------------------------
--fx table of functions
------------------------------------------------------------
g_target_notifier_tab_fx = {}

g_target_notifier_tab_fx[1] = oaxy_target_notifier
g_target_notifier_tab_fx[2] = ouxx_target_notifier
g_target_notifier_tab_fx[3] = odxx_target_notifier
g_target_notifier_tab_fx[4] = ogxx_target_notifier
g_target_notifier_tab_fx[5] = oixx_target_notifier
g_target_notifier_tab_fx[6] = ooxx_target_notifier
g_target_notifier_tab_fx[7] = otxy_target_notifier
g_target_notifier_tab_fx[8] = ocxy_target_notifier
g_target_notifier_tab_fx[9] = osxx_target_notifier
g_target_notifier_tab_fx[10] = obxx_target_notifier
g_target_notifier_tab_fx[11] = ovxy_target_notifier
g_target_notifier_tab_fx[12] = onxy_target_notifier
g_target_notifier_tab_fx[13] = oexx_target_notifier
g_target_notifier_tab_fx[14] = user_target_notifier



---------------------------------------------Sample Commands---------------------------------------------------------
--[[
These commands only apply to samples and will have no effect on the Plugin or MIDI components of an Instrument. When used in the Master track, the effect will be applied to all tracks.

    1 -Axy - Set arpeggio, x/y = first/second note offset in semitones. Using 0 for x or y will use the original note.
    2 -Uxx - Slide pitch up by xx 1/16ths of a semitone (01 is 1/16th of a semitone, 08 is half a semitone, 10 is a whole semitone).
    3 -Dxx - Slide pitch down by xx 1/16ths of a semitone (01 is 1/16th of a semitone, 08 is half a semitone, 10 is a whole semitone).
    4 -Gxx - Glide towards given note by xx 1/16ths of a semitone (01 is 1/16th of a semitone, 08 is half a semitone, 10 is a whole semitone). A value of FF will make the slide instant.
    5 -Ixx - Fade volume in by xx volume units (-I01 inserted 256 times will slide from 0 to full volume, -I7F inserted twice will do the same much faster).
    6 -Oxx - Fade volume out by xx volume units.
    7 -Txy - Set tremolo (regular volume variation), x = speed, y = depth.
    8 -Cxy - Cut volume to x after y ticks (x = volume factor: 0=0%, F=100%).
    9 -Sxx - Trigger sample slice number xx or offset xx.
    10-Bxx - Play sample backwards (xx = 00) or forwards (xx = 01).
    11-Vxy - Set vibrato (regular pitch variation), x = speed, y = depth.
    12-Nxy - Set auto pan (regular pan variation), x = speed, y = depth.
    13-Exx - Set the position of all active Envelope, AHDSR and Fader Modulation devices to offset xx. 
--]]
-----------------------------------------------------------------------------------------------------------------------


--------------------------------------------effect column objext oprint------------------------------------------------

--renoise.song().patterns[].tracks[].lines[]:effect_column(index)

--class: EffectColumn
-- properties:
--    amount_string
--    amount_value
--    is_empty
--    is_selected
--    number_string
--    number_value
-- methods:
--    __STRICT
--    __eq
--    __tostring
--    clear
--    copy_from
-----------------------------------------------------------------------

--renoise.song().tracks[]:swap_effect_columns_at(index1, index2)
--renoise.song().tracks[].sample_effects_column_visible





