
--                  _______________________________________________________
--                  |                                                      |
--             /    |                                                      |
--            /---, |                                                      |
--       -----# ==| |       TIMER   FUNCTION                               |
--       | :) # ==| |                                                      |
--  -----'----#   | |______________________________________________________|
--  |)___()  '#   |______====____   \___________________________________|
-- [_/,-,\"--"------ //,-,  ,-,\\\   |/             //,-,  ,-,  ,-,\\ __#
--   ( 0 )|===******||( 0 )( 0 )||-  o              '( 0 )( 0 )( 0 )||
----'-'--------------'-'--'-'-----------------------'-'--'-'--'-'--------------



-----------------------------
function upper_panel_timer()
-----------------------------
  --primary update global flag, set by this function
  --(needs to be reset to false before any return)
  timer_running = true
  --check bypass global (secondary flag that other functions can set)
  if bypass_timer == true then
    return
  end
  --------
  --renoise song object
  local song = renoise.song()
  --get global target column index
  local col = g_target.column_index
  
 
 
 
 
 
 
  --if user changed name of current track, update the track popup items
  if vb.views["track names"].items[song.selected_track_index] ~= song.selected_track.name then
   --update items in case something changed
   vb.views["track names"].items = get_renoise_track_names()
  end
  
  
  
  
  
  
  
  
  
  
  
  
  
   --debug text
  -- vb.views["debug text"].text = g_target.column_type.." col: "..g_target.column_index.."     Target: "..g_target.value_type
    
--    _    _             _______             _       _____ _                                _   ___  
--   | |  | |           |__   __|           | |     / ____| |                              | | |__ \ 
--   | |__| | __ _ ___     | |_ __ __ _  ___| | __ | |    | |__   __ _ _ __   __ _  ___  __| |    ) |
--   |  __  |/ _` / __|    | | '__/ _` |/ __| |/ / | |    | '_ \ / _` | '_ \ / _` |/ _ \/ _` |   / / 
--   | |  | | (_| \__ \    | | | | (_| | (__|   <  | |____| | | | (_| | | | | (_| |  __/ (_| |  |_|  
--   |_|  |_|\__,_|___/    |_|_|  \__,_|\___|_|\_\  \_____|_| |_|\__,_|_| |_|\__, |\___|\__,_|  (_)  
--                                                                            __/ |                  
--                                                                           |___/                   

  -----------------------------------------
  --1) track changed? 
  -----------------------------------------
  if song.selected_track_index ~= g_stored_track_index then
    --update g_stored_track_index
    g_stored_track_index = song.selected_track_index
    --Change track name popup value 
    vb.views["track names"].value = g_stored_track_index
    --update fx popups
    --clear first (set to ---)
    for i = 1,8 do
      vb.views["popup col "..i].value = #table_of_sample_effects.name_strings 
    end
    --then can fx cols and update popup target automatically for new track
    get_fx_column_targets_for_popups()
    --make sure target of popup is correct
    -- i.e. for vb.views["Note popup col 1"].value
    local selected_note_popup = 2
    
    if song.selected_note_column_index ~= 0 then
    ----NOTE COL--
      note_column_target_notifier(selected_note_popup)
      --change note col target to Note + Volume   
      for j = 1,5 do  
        vb.views["note col target "..j].color = COLOR_GREY
      end
      vb.views["note col target "..DEFAULT_NOTE_COL_TARGET_VALUE].color = COLOR_ORANGE
    else 
    ----FX COL---
      --g_target_notifier_tab_fx[1]()-- = oaxy_target_notifier TODO index with vb.views[..]
      fx_column_buttons_notifier(song.selected_effect_column_index)

    end
    --disable Grab mode if activated
      vb.views["grab button"].color = COLOR_GREY
  end
  -------------------------------------------------------------------------------------------
  --update globals for track type
  -------------------------------------------------------------------------------------------
  
  --table to store all variables needed for sliders notifier "wiring" to the pattern editor
  --g_target = {}
  --g_target.column_index = 1
  --g_target.column_type = "note"
  --g_target.value_type = "volume"
  --g_target.all_note_columns = {}
  --g_target.all_fx_columns = {}
  
  --rprint(g_target)
  
  --check column type and set global table
  if song.selected_note_column_index ~= 0 then
    g_target.column_index = song.selected_note_column_index
    g_target.column_type = "note"
    --last col type
    g_stored_column.type = "note"
  else
    g_target.column_index = song.selected_effect_column_index
    g_target.column_type = "effect"
    --last col type
    g_stored_column.type = "effect"
  end
  
  col = g_target.column_index


 
  ----------------------------------
  --only continue run upper_panel_timer() on a sequencer track 
  if song.selected_track.type ~= renoise.Track.TRACK_TYPE_SEQUENCER then
     for j = 1,tool_range do
       --set all sliders to 0 and make inactive
       vb.views["slider"..j].value = 0
       vb.views["slider"..j].active = false
     end
     vb.views["Selected target"].text = "Won`t Currently Work On Non-Sequencer Tracks"
     timer_running = false
    return
  end
 
  --make sure all sliders are active
  for j = 1,tool_range do
    --set all sliders to 0 and makeactive
    vb.views["slider"..j].active = true
  end
 ----------------------------
 

--     _____      _     _____                               _         
--    / ____|    | |   |  __ \                             | |        
--   | |  __  ___| |_  | |__) |__ _ _ __   __ _  ___    ___| |_ ___   
--   | | |_ |/ _ \ __| |  _  // _` | '_ \ / _` |/ _ \  / _ \ __/ __|  
--   | |__| |  __/ |_  | | \ \ (_| | | | | (_| |  __/ |  __/ || (__ _ 
--    \_____|\___|\__| |_|  \_\__,_|_| |_|\__, |\___|  \___|\__\___(_)
--                                         __/ |                      
--                                        |___/                       

--get the line range in renoise that the tool mirrors

  -- get: pattern/ edit_pos / rns_playback_line
  local rns_edit_line = song.transport.edit_pos
  local pattern_track = renoise.song().selected_pattern_track
  local rns_playback_line = renoise.song().transport.playback_pos.line
 
  --CALCULATE VISIBLE RANGE --What part of pattern will the GUI show?
  -----------------------------------------------------------------
  local function get_display_range_first_line_index()
  -----------------------------------------------
    
    local rns_playback_line = renoise.song().transport.playback_pos.line
    
    --get start line if we are not in first 16 lines of pattern
    if rns_playback_line > tool_range then
      local no_remainder = rns_playback_line - 1
      
      --loop backwards, subtracting one from rns_playback_line,
      --when we hit a multiple of 16 then return
      for i = rns_playback_line,1,-1 do
        if (no_remainder % tool_range) == 0 then --i.e. we are on line 16 or 32 or 48....
          return no_remainder + 1 --add 1 so start line is now 17 or 33 or 49
        else
          no_remainder = no_remainder - 1 --decrement
        end
      end
    else --playback line 16 or less so set to line 1 (default)
      return 1
    end
  end

  --if playline is beyond first section of the pattern that the tool GUI covers
  --then get the next in-pattern range to display
  if rns_playback_line >= tool_range or 1 then --the or 1 catches loop back to start
    g_tool_start_line = get_display_range_first_line_index()
  end
  g_tool_end_line = g_tool_start_line + tool_range


--    ___    _____   ___    _____           _       ____        _   _              
--   |  _|  / ____| |_  |  / ____|         | |     |  _ \      | | | |             
--   | |   | |  __    | | | |  __ _ __ __ _| |__   | |_) |_   _| |_| |_ ___  _ __  
--   | |   | | |_ |   | | | | |_ | '__/ _` | '_ \  |  _ <| | | | __| __/ _ \| '_ \ 
--   | |   | |__| |   | | | |__| | | | (_| | |_) | | |_) | |_| | |_| || (_) | | | |
--   | |_   \_____|  _| |  \_____|_|  \__,_|_.__/  |____/ \__,_|\__|\__\___/|_| |_|
--   |___|          |___|                                                          
--


  --is popup on C-4, if not turn [R] button light grey
  
  
  if vb.views["target note"].value == 72 then --72 == c-4 (notes in reversed order)
    vb.views["R button"].color = COLOR_GREY
  else
    vb.views["R button"].color = COLOR_GREY_LIGHT
  end
                                             
  --NOTE GRAB function [G] button, do following when enabled
  ----------------------------------------------------------                   --assert(g_target.value_type == "note + volume") then
   if (vb.views["grab button"].color[1] == GRAB_BUTTON_ENABLED_COLOR_FLAG) and (g_target.value_type == "note + volume") then 
     vb.views["grab lane enabled cb"].visible = true
     --disable this mode by turning G button grey if "Note + Volume" button becomes unchecked
     if vb.views["note col target "..2].color[1] == COLOR_GREY_FLAG then
       --G button to Grey
       vb.views["grab button"].color = COLOR_GREY
       timer_running = false
       return
     end

     --disable this mode if edit mode is switched on in renoise by the user then quit grab mode
     if song.transport.edit_mode == true then
       --G button to Grey
       vb.views["grab button"].color = COLOR_GREY
       timer_running = false
       return
     end
     --get key from keyhandler
     -------------------------
     local note_value = nil
     if g_keyhandler_value ~= nil then 
       --check a legitimate (not playing) qwerty key has been pressed
       if g_keyhandler_value.note ~= nil then
         --get the note value --e.g. A-4 (number)
         note_value =  g_keyhandler_value.note 

         --renoise octave
         local octave = renoise.song().transport.octave
         --increment to match to popup values
        -- note_value = note_value + 1
         --multiply by octave
         note_value = note_value + (octave * 12)
         
         --reverse number index for popup (which is in reverse order)
         note_value = 120 - note_value
         
         print(note_value)
         if note_value > 0 and note_value < 121 then --keep in range
          --update target popup
          vb.views["target note"].value = note_value  
          local text = vb.views["target note"].items[note_value]
         -- local note
          if g_grab_extra_target_button ~= nil then
          --add/ update note
          local target_line = (g_tool_start_line + g_grab_extra_target_button - 1)
          --[col][target_pat_line]
          g_target.all_note_columns[g_target.column_index][target_line].note_string = text
          g_target.all_note_columns[g_target.column_index][target_line].instrument_value = (song.selected_instrument_index - 1)
          

           --reflect note in extra buttons
          -- local note_text = vb.views["target note"].items[note_value]
            if g_grab_extra_target_button ~= nil then
              --clear all text in whole row
              for i = 1,tool_range do
                vb.views["grab extra"..i].text =""
              end
              --show the note text in the target button
              vb.views["grab extra"..g_grab_extra_target_button].text = text 
            end
          end
        end
      end
      --(for efficiency) reset global so the above only runs when a new key has been pressed again by user 
      g_keyhandler_value = nil 
    end
  else
    --turn grab button grey if still enabled (this occurs when user chooses another non "Note + Volume" target for the sliders
    vb.views["grab button"].color = COLOR_GREY
    --hide grab lane checkbox
    vb.views["grab lane enabled cb"].visible = false
    --hide extra buttons under the transport buttons
    if vb.views["grab extra1"].visible == true then
      show_grab_extra_buttons(false)
    end  
  end  
  
                                                                     
  -------------------------------------------------------------------------
  ----UPDATE GUI----Set Note Names in textfields under the sliders---------
  -------------------------------------------------------------------------    
--    ____  _____  __  __                   _   _  _____ ____  _        _           _   _                  _  
--   |  _ \|  __ \|  \/  |                 | | ( )/ ____/ __ \| |      | |         | | | |                ( )  
--   | |_) | |__) | \  / |   __ _ _ __   __| |  \| |   | |  | | |      | |__  _   _| |_| |_ ___  _ __  ___ \| 
--   |  _ <|  ___/| |\/| |  / _` | '_ \ / _` |   | |   | |  | | |      | '_ \| | | | __| __/ _ \| '_ \/ __|   
--   | |_) | |    | |  | | | (_| | | | | (_| |   | |___| |__| | |____  | |_) | |_| | |_| || (_) | | | \__ \    
--   |____/|_|    |_|  |_|  \__,_|_| |_|\__,_|    \_____\____/|______| |_.__/ \__,_|\__|\__\___/|_| |_|___/  
--                                                                                                                              
                                                                                                                                                                                                                  
 --set bpm button color YELLOW if 1/2 bpm
  --------------------------------
  local function get_bpm_button_color()
  --------------------------------
    if song.transport.bpm == g_original_bpm then
      return COLOR_GREY
    else
      return COLOR_YELLOW
    end 
  end
  vb.views["bpm button"].color = get_bpm_button_color()
  --------------------------------
  
  --update visible/text state of note col buttons
  local vis_cols = song.selected_track.visible_note_columns
  for i = 1,12 do
    vb.views["Note Column Button "..i].text = ""
  end
  for i = 1,(vis_cols) do
    vb.views["Note Column Button "..i].text =  "NOTE "..i
  end
  --update visible/text fx col buttons
  --update visible/text note col buttons
  local vis_cols = song.selected_track.visible_effect_columns
  for i = 1,8 do
    vb.views["Fx Column Button "..i].text = ""
  end
  for i = 1,(vis_cols) do
    vb.views["Fx Column Button "..i].text =  "FX "..i
  end
  
  
--    _   _       _         _______        _    __ _      _     _     
--   | \ | |     | |       |__   __|      | |  / _(_)    | |   | |    
--   |  \| | ___ | |_ ___     | | _____  _| |_| |_ _  ___| | __| |___ 
--   | . ` |/ _ \| __/ _ \    | |/ _ \ \/ / __|  _| |/ _ \ |/ _` / __|
--   | |\  | (_) | ||  __/    | |  __/>  <| |_| | | |  __/ | (_| \__ \
--   |_| \_|\___/ \__\___|    |_|\___/_/\_\\__|_| |_|\___|_|\__,_|___/
                                                                  
  
  --NOTE NAME TEXFIELDS--
  --update note names in textfields, below the main sliders
  for i = 1,tool_range do
    local _col = col
    --when an fx lane is chosen, show the notes from note column 1
    if g_target.column_type == "effect" then
      _col = 1
    end
       
    local note = pattern_track:line(g_tool_start_line + i -1):note_column(_col) 
    
    if vb.views["note name textfield"..i].edit_mode == false then --skip when user typing something
      vb.views["note name textfield"..i].value = note.note_string
      
      --clear empty notes from readouts
      if vb.views["note name textfield"..i].value == "---"  then -- or vb.views["note name textfield"..i].value == "OFF" then
        vb.views["note name textfield"..i].value = ""
         --transport buttons
        vb.views["transport button"..i].text = ""
      end 
      if vb.views["note name textfield"..i].value == "OFF" then
        vb.views["off button"..i].color = NOTE_OFF_BUTTON_ENABLED_COLOR
      else
        vb.views["off button"..i].color = COLOR_GREY
      end 
    end 
  end
  
  

--    _______                   _     _____                _             _   
--   |__   __|                 | |   |  __ \              | |           | |  
--      | | __ _ _ __ __ _  ___| |_  | |__) |___  __ _  __| | ___  _   _| |_ 
--      | |/ _` | '__/ _` |/ _ \ __| |  _  // _ \/ _` |/ _` |/ _ \| | | | __|
--      | | (_| | | | (_| |  __/ |_  | | \ \  __/ (_| | (_| | (_) | |_| | |_ 
--      |_|\__,_|_|  \__, |\___|\__| |_|  \_\___|\__,_|\__,_|\___/ \__,_|\__|
--                    __/ |                                                  
--                   |___/                                                   
 
  --modify if bypassed i.e. when fx column is chosen but no target selected in the relevant popup 
  local target_text =  string.upper(g_target.value_type)
  if target_text == "BYPASSED" then
     target_text = "BYPASSED:  No Slider Target Chosen "
  end
  --write to readout
  vb.views["Selected target"].text = target_text


--    _    _           _       _         _______                                   _     ____        _   _                  
--   | |  | |         | |     | |       |__   __|                                 | |   |  _ \      | | | |                 
--   | |  | |_ __   __| | __ _| |_ ___     | |_ __ __ _ _ __  ___ _ __   ___  _ __| |_  | |_) |_   _| |_| |_ ___  _ __  ___ 
--   | |  | | '_ \ / _` |/ _` | __/ _ \    | | '__/ _` | '_ \/ __| '_ \ / _ \| '__| __| |  _ <| | | | __| __/ _ \| '_ \/ __|
--   | |__| | |_) | (_| | (_| | ||  __/    | | | | (_| | | | \__ \ |_) | (_) | |  | |_  | |_) | |_| | |_| || (_) | | | \__ \
--    \____/| .__/ \__,_|\__,_|\__\___|    |_|_|  \__,_|_| |_|___/ .__/ \___/|_|   \__| |____/ \__,_|\__|\__\___/|_| |_|___/
--          | |                                                  | |                                                        
--          |_|                                                  |_|                                                        


  --get renoise block loop values
  local rns_loop_start = song.transport.loop_start.line 
  local rns_loop_end = song.transport.loop_end.line - 1
  local rns_loop_enabled = song.transport.loop_block_enabled 
  local offset = (g_tool_start_line - 1) --works
  tool_offset = offset
  
  --update transport button colours
  ----------------------------------
  for step = 1,tool_range do
    --show playback pos as blue (shows if rns edit pos is not linked to playback line)
    if step + offset == rns_playback_line then
      vb.views["transport button"..step].color = COLOR_BLUE
    else
     --if block loop is enabled, color the relevant buttons green
      if (rns_loop_enabled == true)
        and (step + offset >= rns_loop_start)
         and (step + offset <= rns_loop_end) then
        vb.views["transport button"..step].color = COLOR_GREEN
      else
        vb.views["transport button"..step].color = COLOR_GREY
      end
    end
    --set edit pos to orange on gui buttons
    if (step + offset) == rns_edit_line.line then
      vb.views["transport button"..step].color = COLOR_ORANGE
    end
    --update transport button text
    ------------------------------
    --The variable `options.transport_text_flag.value` can have the values "beat markers","pattern line numbers" or "pattern notes"--
    --this determines what text is shown on the transport buttons (user clicking one of the buttons in the gui, changes this variable i.e. it`s mode)
    if options.transport_text_flag.value == "pattern notes" then
      local _col = col
      --when an fx lane is chosen, show the notes from note column 1
      if g_target.column_type == "effect" then
        _col = 1
      end
      --get note
      local note = pattern_track:line(g_tool_start_line + step -1):note_column(_col)
      local note_string = note.note_string 
      --weed out empty pattern notes and update text
      if note_string ~= "---" then
        vb.views["transport button"..step].text = note.note_string
      else
        vb.views["transport button"..step].text = ""
      end
    elseif options.transport_text_flag.value == "pattern line numbers" then
        vb.views["transport button"..step].text = tostring(step + offset - 1)
    elseif options.transport_text_flag.value == "beat markers" then
      local lpb = song.transport.lpb
      if (step -1) % lpb == 0 then
        vb.views["transport button"..step].text = "|"
      else
       vb.views["transport button"..step].text = ""
      end
    end
  end
  
  

--    _    _           _       _          _____ _                _____               _____ _ _     _               
--   | |  | |         | |     | |        / ____| |              / ____|             / ____| (_)   | |              
--   | |  | |_ __   __| | __ _| |_ ___  | (___ | |_ ___ _ __   | (___   ___  __ _  | (___ | |_  __| | ___ _ __ ___ 
--   | |  | | '_ \ / _` |/ _` | __/ _ \  \___ \| __/ _ \ '_ \   \___ \ / _ \/ _` |  \___ \| | |/ _` |/ _ \ '__/ __|
--   | |__| | |_) | (_| | (_| | ||  __/  ____) | ||  __/ |_) |  ____) |  __/ (_| |  ____) | | | (_| |  __/ |  \__ \
--    \____/| .__/ \__,_|\__,_|\__\___| |_____/ \__\___| .__/  |_____/ \___|\__, | |_____/|_|_|\__,_|\___|_|  |___/
--          | |                                        | |                     | |                                 
--          |_|                                        |_|                     |_|                                 

-------------------------------------------------------------------------------------------------------------------    
  
   local X_BUTTON_ACTIVE_COLOR = COLOR_GREY_LIGHT
  
  --UPDATE GUI SLIDERS-------Set Slider Values
  ----------------------------------------------
  --check which value_type is active
  --loop slider range
  --get note/value/fx/value
  --weed out unwanted values like empty lines
  --set gui slider via vb.views[..
  
   if g_target.value_type == "bypassed" then
     for j = 1,tool_range do
       --set all sliders to 0 and make inactive
       vb.views["slider"..j].value = 0 
       vb.views["slider"..j].active = false
       vb.views["X button"..j].color = COLOR_GREY
     end
   elseif vb.views["slider"..1].active == false then--check whether sliders are bypassed and acivate (when not flagged as such)
     for j = 1,tool_range do
       vb.views["slider"..j].active = true
     end
   end
   --PITCH--
   if g_target.value_type == "pitch" then
    for i = 1,tool_range do
   
    -- vb.views["X button"..i].text = ""
     
      --wire pattern to sliders
      local note = pattern_track:line(g_tool_start_line + i -1 ):note_column(col)
      local value = note.note_value
      --1) OFF found
      if note.note_string == "OFF" then
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
       -- b.views["X button"..i].text = ""
       --2) EMPTY
      elseif value > 119 then --weed out note off and empty lines
        value = 1
        vb.views["X button"..i].color = COLOR_GREY
       -- vb.views["X button"..i].text = note.note_string
        vb.views["slider"..i].value = value
       -- vb.views["X button"..i].text = ""
      --3) NOTE
      elseif note.note_string == "C-4" then
       vb.views["X button"..i].color = COLOR_GREY
       vb.views["slider"..i].value = value
      -- vb.views["X button"..i].text = "x"
       -- vb.views["X button"..i].text = ""
      else
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
       -- vb.views["X button"..i].color = COLOR_GREY
        --vb.views["X button"..i].text = "x"
      -- vb.views["X button"..i].text = ""
      end
    end
     
  elseif g_target.value_type == "note + volume" then
     
     
   
    for i = 1,tool_range do
    
     -- vb.views["X button"..i].text = ""
     
      local note = pattern_track:line(g_tool_start_line + i -1 ):note_column(col)
      local vol = note.volume_value
      
      if (note.note_string ~= "---") and (note.note_string ~= "OFF") and (note.volume_string == "..")  then --empty
      --NOTE FOUND, empty volume
       
       vb.views["slider"..i].value = VEL_SLIDER_MAX
       vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      -- vb.views["X button"..i].text = "x" --note.volume_string--"x"
      elseif (note.note_string ~= "---") and (vol > 0) and (vol < 129) then
        --note present and volume (1 to (max -80))
       
        vb.views["slider"..i].value = note.volume_value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
        --vb.views["X button"..i].color = COLOR_GREY
        -- vb.views["X button"..i].text = "x" --note.volume_string
      elseif vol == 0 then
        --note and emty vol
        
        vb.views["X button"..i].color = COLOR_RED_MILD
       -- vb.views["X button"..i].text =  "0"--note.note_string--note.volume_string
        vb.views["slider"..i].value = 0
      else
        --empty note /  empty so vol 
        
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
       -- vb.views["X button"..i].text = ""-- note.volume_string
      end
      if note.note_string == "OFF" then
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
       -- vb.views["X button"..i].text = ""
      end
    end   
  elseif g_target.value_type == "volume" then
    for i = 1,tool_range do
      local note = pattern_track:line(g_tool_start_line + i -1 ):note_column(col)
      local vol = note.volume_value
       
      if vol == 255  and note.note_string ~= "OFF" then --empty
       --empty vol with a note
       vb.views["slider"..i].value = VEL_SLIDER_MAX
       vb.views["X button"..i].color = COLOR_GREY
      -- vb.views["X button"..i].text =  note.volume_string
      elseif  vol < 128 then
        --legitimate volume value
        vb.views["slider"..i].value = note.volume_value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
       -- vb.views["X button"..i].text = note.volume_string
      else
        vb.views["X button"..i].color = COLOR_GREY
       -- vb.views["X button"..i].text = note.volume_string
        --no legitimate vol value 
        --vb.views["slider"..i].value = 0
      end
      if note.note_string == "OFF" then
        vb.views["slider"..i].value = 0
       -- vb.views["X button"..i].text = "OFF"
        vb.views["X button"..i].color = COLOR_GREY
      end
    end

 
  elseif g_target.value_type == "pan" then
  
    
    for i = 1,tool_range do
    -- vb.views["X button"..i].text = ""
    
      --wire pattern to sliders
      local note = pattern_track:line(g_tool_start_line + i -1 ):note_column(col)
      local value = note.panning_value
       if value > 127 then --weed out note off and empty lines
        value = 64 --mid pan
        vb.views["X button"..i].color = COLOR_GREY
       -- vb.views["X button"..i].text = ""
        vb.views["slider"..i].value = value
      else
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
       -- vb.views["X button"..i].text = note.panning_string
        vb.views["slider"..i].value = value
      end
      if note.note_string == "OFF" then
       -- vb.views["X button"..i].text = "OFF"
      end
    end
    
   --/pan/delay/ pitch
  elseif g_target.value_type == "delay" then
    for i = 1,tool_range do
      --wire pattern to sliders
      local note = pattern_track:line(g_tool_start_line + i -1 ):note_column(col)
      vb.views["slider"..i].value = note.delay_value
      if note.delay_value > 0 then
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      --  vb.views["X button"..i].text = note.delay_string
      else
        vb.views["X button"..i].color = COLOR_GREY
       -- vb.views["X button"..i].text = ""
      end
      if note.note_string == "OFF" then
        vb.views["X button"..i].color = COLOR_GREY
        local delay_string = note.delay_string
        if  delay_string == ".."then
        --  vb.views["X button"..i].text = ""
        else
        --  vb.views["X button"..i].text = note.delay_string
        end
      end
      
    end
  --column fx
  elseif g_target.value_type == "0axy (Arpeggio)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0A" then--check if it`s correct command
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  elseif g_target.value_type == "0uxx (Slide Pitch up)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0U" then--check if it`s correct command
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  elseif g_target.value_type == "0dxx (Slide Pitch Down)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0D" then--check if it`s correct command
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  elseif g_target.value_type == "0gxx (Glide Towards Note)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col)
      local value = fx.amount_value 
      if fx.number_string == "0G" then
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  elseif g_target.value_type == "0ixx (Fade Volume In)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0I" then--check if it`s correct command
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  elseif g_target.value_type == "0oxx (Fade Volume Out)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0O" then--check if it`s correct command
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  elseif g_target.value_type == "0txy (Tremolo)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0T" then--check if it`s correct command
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  
  

  elseif g_target.value_type == "0cxy (Cut Note)" then 
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0C" then--check if it`s correct command
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  
  

  
  elseif g_target.value_type == "0sxx (Trigger Sample Slice / Offset)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0S" then--check if it`s correct command
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  
  
  elseif g_target.value_type == "0bxx (Play Backwards)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      local value = fx.amount_value
       if value == 1 then --scale to 1/ 0 value
          value = 0   --reverse values for backwards command (makes more sense with sliders)
        else 
          value = 1 
        end 
      if fx.number_string == "0B" then--check if it`s correct command
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  
  
  elseif g_target.value_type == "0vxy (Vibrato)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0V" then--check if it`s correct command
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  
  
  elseif g_target.value_type == "0nxy (Auto Pan)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0N" then--check if it`s correct command 
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end
  
  
  elseif g_target.value_type == "0exx (Envelope Pos)" then
    for i = 1,tool_range do
      local fx = pattern_track:line(g_tool_start_line + i -1 ):effect_column(col) 
      if fx.number_string == "0E" then--check if it`s correct command
        local value = fx.amount_value
        vb.views["slider"..i].value = value
        vb.views["X button"..i].color = X_BUTTON_ACTIVE_COLOR
      else
        vb.views["slider"..i].value = 0
        vb.views["X button"..i].color = COLOR_GREY
      end
    end

  end
   
  --HOUSEKEEPING -----remove timer when GUI is closed
  ---------------------------------
  if(my_dialog == nil) or (my_dialog.visible == false) then
  
    if renoise.tool():has_timer(upper_panel_timer) then
      renoise.tool():remove_timer(upper_panel_timer)
      song.transport.bpm = g_original_bpm 
    end
  end
  --reset timer flag
  ------------------
  timer_running = false
end
