

TOOL_NAME = "I Can Haz Sequencer!"

-------------------------------
--Renoise Keybinds and menus
-------------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:"..TOOL_NAME,
  invoke = function()main()end  
}

renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:"..TOOL_NAME,
  invoke = function()main()end  
}


 
------------------------------------------------------
--modified print out shows what tool the print is from
------------------------------------------------------
tprint = function(text)
  print(TOOL_NAME..": "..tostring(text))
end


--colours
---------
--e.g. For changing vb.views["button_x"].color when states change
COLOR_GREY = {40,40,40}
COLOR_ORANGE ={0xFF,0x66,0x00}
COLOR_YELLOW = {0xE0,0xE0,0x00}

--COLOR_YELLOW_MILD = {0xE0,0xD2,0x72}
COLOR_GREY_LIGHT = {0x7A,0x7A,0x7A}

COLOR_BLUE = {0x50,0x40,0xE0}  
COLOR_RED = {0xBB,0x10,0x10}
COLOR_RED_MILD = {0x70,0x10,0x10}
COLOR_GREEN = {0x20,0x99,0x20}

--to test `vb.views["button_x"].color` we need to check the second entry of the color table
--i.e. if vb.views["button_x"].color[1] == COLOR_GREY_FLAG
COLOR_GREY_FLAG = 40
COLOR_ORANGE_FLAG = 0xFF
COLOR_YELLOW_FLAG = 0xE0

--COLOR_YELLOW_MILD_FLAG = 0xE0
COLOR_GREY_LIGHT_FLAG = 0xD3

COLOR_BLUE_FLAG = 0x50 
COLOR_RED_FLAG = 0xBB
COLOR_RED_MILD_FLAG = 0x70
COLOR_GREEN_FLAG = 0x20

--COLORS SPECIFIC TO BUTTONS (allows easier changing)
--grab button
GRAB_BUTTON_ENABLED_COLOR = COLOR_ORANGE
GRAB_BUTTON_ENABLED_COLOR_FLAG = COLOR_ORANGE_FLAG
--note off button
NOTE_OFF_BUTTON_ENABLED_COLOR = COLOR_BLUE
NOTE_OFF_BUTTON_ENABLED_COLOR_FLAG = COLOR_BLUE_FLAG



--global constants
------------------
LUA_COUNTS_FROM_1 = 1
VEL_SLIDER_MAX = 129  --zero 0x00 to [0x80 == 128] + 1 for empty
DEL_SLIDER_MAX = 80
SLIDER_WIDTH = 35
DEFAULT_NOTE_COL_TARGET_VALUE = 2 --vol and pan
RENOISE_NOTES_COUNT_FROM_0 = 1


------------------------------------------
--Set up Preferences file
------------------------------------------
--create xml
options = renoise.Document.create {
  transport_text_flag = "beat markers",
  grab_target_lane_checkbox_enabled = true,
  show_off_or_x_buttons_popup = 1,
  delay_rotaries_visible = false,
  chord_mode_enabled = false,
}
 --assign options-object to .preferences so renoise knows to load and update it with the tool
renoise.tool().preferences = options
------------------------------------------
------------------------------------------
--variable syntax 
--options.variable_name.value


--globals variables
-------------------
g_stored_track_index = nil

g_stored_column = {}
g_stored_column.index = nil
g_stored_column.type = nil --"note" or "effect"

--when the fx `USER` selected in popup, this stores the number i.e. 14 for device 1 parameter 4
--default is "00"
g_user_effect_number_string = "00"

user_target_note = "C-4"
g_original_bpm = nil 
g_tool_start_line = 1

tool_range = 32
tool_offset= 0

g_tool_end_line = tool_range

g_target_notifier_tab = nil

--table to store all variables needed for sliders notifier "wiring" to the pattern editor
g_target = {}
g_target.column_index = 1
g_target.column_type = "note"
g_target.value_type = "volume"
g_target.default_note = 48 --C-4 = 48 in renoise  --   C-0 == 0, B-9 == 119 ---
g_target.all_note_columns = {}
g_target.all_fx_columns = {}

--lower panel globals  
g_slider_lane_target = {}
slider_lane_chosen_button = "delay"
g_slider_lane_one_col_target_index = 1 --default to 1
g_slider_lane_two_col_target_index = 1 --default to 1

g_grab_extra_target_button = nil
--timer flags
timer_running = false
bypass_timer = false

textfield_flag = true

--global variables for gui
my_dialog = nil 
vb = nil
lower_panel = nil
dialog_content = nil

g_keyhandler_value = nil

--------------------------------------------------------------------------------
--helper function : custom status message --prefixes tool name and adds brackets 
--------------------------------------------------------------------------------
function status(message)
  renoise.app():show_status(TOOL_NAME.." Tool: ("..message..")")
end
------------------------------------------
--remove all of tools notifiers and timers
------------------------------------------
function remove_notifiers()
  -- remove_notifiers()
  if renoise.tool():has_timer(upper_panel_timer) then
    renoise.tool():remove_timer(upper_panel_timer)
    return true
  end
  return false
end
------------
--main
------------

--get other lua files
--require "_2_lower_panel"
require "_gui"
require "shortcuts"

function main()
  --call upper panel function
  main_upper_panel()
end





