local function status(message)
  renoise.app():show_status("I Can Haz Sequencer!".." Tool: ("..message..")")
end

renoise.tool():add_keybinding {
  name = "Global:Tools: `ICH` select all fx entries in column",
  invoke = function()set_selection_to_first_and_last_fx_in_col()end  
}

--function sets the pattern editor selection
--to the first and last fx entries so interpolation can be added easily
----------------------------------------------------
function set_selection_to_first_and_last_fx_in_col()
---------------------------------------------------

  local song = renoise.song()
  local first_fx_line = nil
  local last_fx_line = nil
  local col = song.selected_effect_column_index
  
  
  
  --loop to get first and last entries
  for line = 1,#song.selected_pattern_track.lines do
    --get position of first value
    if (first_fx_line == nil) and (song.selected_pattern_track:line(line):effect_column(col).is_empty == false) then
      first_fx_line = line--song.selected_pattern_track:line(line):effect_column(col).number_value
    end
    --get position of last value
    if (song.selected_pattern_track:line(line):effect_column(col).is_empty == false) then
      last_fx_line = line--song.selected_pattern_track:line(line):effect_column(col).number_value
    end
  end
  
  --return and show status if no range is found
  if (first_fx_line == nil) or (last_fx_line == nil) then
    status("No Range Found")
    return
  end
  
  --selection `sees` columns as the same so we need to add the visible note columns to offset
  local visible_note_cols = song.selected_track.visible_note_columns
  col = col + visible_note_cols 
  
   --create a selection table
  local select = {
    start_line = first_fx_line,
    start_track = song.selected_track_index,
    start_column = col,
    end_line = last_fx_line,
    end_track = song.selected_track_index,
    end_column = col ,}
  
  --update renoise selection
  song.selection_in_pattern = select
  



end
